;###############################################################################
/* Selector for LilBuilder

*/
;###############################################################################

Selector_GuiID(){
  Return 1
}

Selector_HWND(HWND=""){
  static Selector_HWND
  If HWND
     Selector_HWND = %HWND%
  Return %Selector_HWND%
}

Selector_Create() {
   local Selector_GuiID
   Selector_GuiID := Selector_GuiID()
   Gui, %Selector_GuiID%:+LastFound -Caption +Resize +ToolWindow +LabelSelector_ ;AlwaysOnTop
   Gui, %Selector_GuiID%:Color, FFFF
   WInSet, Transparent, 100
   Selector_HWND(WinExist())
}

Selector_Size:
   If Selector_Set2Ctrl    ;don't resize when Selector is set 2 Ctrl
      Return
   If GRID()
       Selector_UpdateCtrlwGrid()
   else Selector_UpdateCtrl()
   SetTimer, Selector_UpdateItself, 100
return

Selector_Set2Ctrl(){
   global Selector_Set2Ctrl, Selector_CtrlHwnd
   Selector_HWND := Selector_HWND()
   Selector_GuiID := Selector_GuiID()
   Selector_Set2Ctrl := True
   WinGetPos, ux, uy,,, % "ahk_id " Gui_HWND()
   ControlGetPos, sx,sy,sw,sh,, ahk_id %Selector_CtrlHwnd%
   WinMove, ahk_id %Selector_hwnd%, ,sx + ux, sy + uy, sw, sh
   Gui %Selector_GuiID%:Show
   WinActivate,  ahk_id %Selector_hwnd%
   Sleep, 50     ;sleep needed, otherwise Selector_Size doesn't get Selector_Set2Ctrl
   Selector_Set2Ctrl := False
}

; Update control to match cursor's size   and position
Selector_UpdateCtrl(){
   global Selector_CtrlHwnd
   Selector_HWND := Selector_HWND()
   WinGetPos, ux, uy,,, % "ahk_id " Gui_HWND()
   WinGetPos, sx,sy,sw,sh, ahk_id %Selector_hwnd%
   ControlMove,, sx-ux, sy-uy, sw, sh, ahk_id %Selector_CtrlHwnd%
   SetTimer, Gui_Refresh, -500
}

Selector_UpdateItself:
  If !GetKeyState("LButton"){
      SetTimer, Selector_UpdateItself, Off
      Selector_Set2Ctrl()
  }
Return

Selector_UpdateCtrlwGrid() {
   global Selector_CtrlHwnd
   Selector_HWND := Selector_HWND()
   WinGetPos, ux, uy, , , % "ahk_id " Gui_HWND()
   WinGetPos, cx, cy ,cw, ch, ahk_id %Selector_hwnd%
   cx -= ux, cy -= uy ;relative position
   GRID := Grid()
   dx := Mod(cx, GRID), dy := Mod(cy, GRID), dw := Mod(cw, GRID), dh := Mod(ch, GRID)   ;snap to grid
   dx -= (dx ? GRID : 0),cx -= dx, dy -= (dy ? GRID : 0),cy -= dy
   cw -= (cw > dw ? dw : 0), ch -= (ch > dh ? dh : 0)
   ControlMove,,cx,cy,cw,ch, ahk_id %Selector_CtrlHwnd%
}

Selector_OnDelete:
   DllCall("DestroyWindow", "uint", Selector_CtrlHwnd)
   WinActivate, % "ahk_id " Gui_HWND()      ;hide the cursor besides
return

Selector_Hide() {    ;??? not used
   global
   Selector_CtrlHwnd =
   WinHide, % "ahk_id " Selector_HWND()
}
