;###############################################################################
/* ToolBox for LilBuilder

*/
;###############################################################################

Toolbox_GuiID(){
  Return 2
}

Toolbox_HWND(HWND=""){
  static Toolbox_HWND
  If HWND
     Toolbox_HWND = %HWND%
  Return %Toolbox_HWND%
}

Toolbox_Create() {
   local Toolbox_GuiID
   Toolbox_GuiID := Toolbox_GuiID()
   
   Gui %Toolbox_GuiID%:Font, bold
   gui %Toolbox_GuiID%:+LastFound +ToolWindow +LabelToolbox_
   gui %Toolbox_GuiID%:add, Text, x5, AHK controls
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\Text.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\Edit.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\ComboBox.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\Button.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\CheckBox.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\Radio.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\Picture.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\ListBox.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\ListView.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\TreeView.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\Tab.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\HotKey.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\Groupbox.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\DateTime.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\MonthCal.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\Progress.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\UpDown.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\Slider.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Std\StatusBar.png

   gui %Toolbox_GuiID%:add, Text, y+20, Custom controls
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Cst\HiEdit.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Cst\HLink.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Cst\RaGrid.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick ,res\Cst\IE.png

   Toolbox_Std := "Text,Edit,ComboBox,Button,CheckBox,Radio,Picture,ListBox,ListView,TreeView,Tab,HotKey,GroupBox,DateTime,MonthCal,Progress,UpDown,Slider,StatusBar"

   Gui %Toolbox_GuiID%:Show, x-1000, ToolBox

   Toolbox_HWND(WinExist())
}

;###############################################################################

Toolbox_OnClick:
   Toolbox_OnClick()
return
Toolbox_OnClick() {
   local caption, txt, ux, uy, cw, ch , Gui_GuiID, Toolbox_GuiID
   static Gui_ctrlCnt = 0

   Gui_GuiID := Gui_GuiID()
   Toolbox_GuiID := Toolbox_GuiID()
   
   Gui_ctrlCnt++
   GuiControlGet, txt, %Toolbox_GuiID%: , %A_GuiControl%
   SplitPath, txt, ,,,txt

   caption := txt " Control " Gui_ctrlCnt
   if txt = Picture
      caption := A_WinDir "\Notepad.exe"

   if txt in %Toolbox_Std%
   {
      Gui, %Gui_GuiID%:Add, %txt%, x0 y0 vNew%Gui_ctrlCnt% HWNDID%Gui_ctrlCnt%, %caption%
      Selector_CtrlHwnd := ID%Gui_ctrlCnt%
      Type%Selector_CtrlHwnd% = %txt%             ;store type of control in list
      Var%Selector_CtrlHwnd% = New%Gui_ctrlCnt%  ;store controls variable in list

   }
   else {
      if txt = HiEdit
         Selector_CtrlHwnd := HE_Add( Gui_HWND(), 0, 0, 300, 200)

      else if txt = HLink
         Selector_CtrlHwnd := HLink_Add( Gui_HWND(), "Click <a href=""http://www.Google.com"">here</a>", 0, 0, 80, 20)

      else if txt = RaGrid
      {
         RG_Init()
         Selector_CtrlHwnd := RG_Add(Gui_HWND(), 0, 0, 220, 150, STYLE_VGRIDLINES | STYLE_GRIDLINES )
         RG_AddColumn(Selector_CtrlHwnd, "cap=Col1", "w=150" )
         RG_AddColumn(Selector_CtrlHwnd, "cap=Col2", "w=50")
         RG_SetHdrHeight(Selector_CtrlHwnd, 25)
      }

      else if txt = IE
      {
         pwb := IE_Add( Gui_HWND(), 0, 0, 200, 200)
         IE_LoadHTML(pwb, "<a href=""http://www.autohotkey.com/forum/viewtopic.php?t=19225&start=0"">IE Control</a>")
      }
   }

   WinGetPos, ux, uy,,, % "ahk_id " Gui_HWND()
   ControlGetPos, ,,cw,ch,, ahk_id %Selector_CtrlHwnd%
   MouseMove, ux + cw // 2, uy + SM_CYSIZEFRAME + SM_CYCAPTION + ch // 2

   Selector_Set2Ctrl()
   Send {LButton down}
}

;###############################################################################
